#include "clisp.h"

extern object module__postgresql__object_tab[];
#include <config.h>
#if defined(HAVE_POSTGRES_EXT_H)
#  include <postgres_ext.h>
#elif defined(HAVE_POSTGRESQL_POSTGRES_EXT_H)
#  include <postgresql/postgres_ext.h>
#elif defined(HAVE_PGSQL_POSTGRES_EXT_H)
#  include <pgsql/postgres_ext.h>
#else
#  error "PostgreSQL is not found"
#endif
#if defined(HAVE_POSTGRES_EXT_H)
#  include <libpq-fe.h>
#elif defined(HAVE_POSTGRESQL_POSTGRES_EXT_H)
#  include <postgresql/libpq-fe.h>
#elif defined(HAVE_PGSQL_POSTGRES_EXT_H)
#  include <pgsql/libpq-fe.h>
#else
#  error "PostgreSQL is not found"
#endif

subr_t module__postgresql__subr_tab[1];
uintC module__postgresql__subr_tab_size = 0;
subr_initdata_t module__postgresql__subr_tab_initdata[1];

object module__postgresql__object_tab[1];
object_initdata_t module__postgresql__object_tab_initdata[1];
uintC module__postgresql__object_tab_size = 0;


void module__postgresql__init_function_1 (module_t* module);

void module__postgresql__init_function_2 (module_t* module);

void module__postgresql__fini_function (module_t* module);


void module__postgresql__init_function_1 (module_t* module)
{
}

void module__postgresql__init_function_2 (module_t* module)
{
# if defined(HAVE_PQCONNECTSTART)
  register_foreign_function((void*)&PQconnectStart,"PQconnectStart",1024);
# endif
# if defined(HAVE_PQCONNECTPOLL)
  register_foreign_function((void*)&PQconnectPoll,"PQconnectPoll",1024);
# endif
# if defined(HAVE_PQCONNECTDB)
  register_foreign_function((void*)&PQconnectdb,"PQconnectdb",1024);
# endif
# if defined(HAVE_PQSETDBLOGIN)
  register_foreign_function((void*)&PQsetdbLogin,"PQsetdbLogin",1024);
# endif
# if defined(HAVE_PQFINISH)
  register_foreign_function((void*)&PQfinish,"PQfinish",1024);
# endif
# if defined(HAVE_PQCONNDEFAULTS)
  register_foreign_function((void*)&PQconndefaults,"PQconndefaults",1024);
# endif
# if defined(HAVE_PQCONNINFOFREE)
  register_foreign_function((void*)&PQconninfoFree,"PQconninfoFree",1024);
# endif
# if defined(HAVE_PQRESETSTART)
  register_foreign_function((void*)&PQresetStart,"PQresetStart",1024);
# endif
# if defined(HAVE_PQRESETPOLL)
  register_foreign_function((void*)&PQresetPoll,"PQresetPoll",1024);
# endif
# if defined(HAVE_PQRESET)
  register_foreign_function((void*)&PQreset,"PQreset",1024);
# endif
# if defined(HAVE_PQGETCANCEL)
  register_foreign_function((void*)&PQgetCancel,"PQgetCancel",1024);
# endif
# if defined(HAVE_PQFREECANCEL)
  register_foreign_function((void*)&PQfreeCancel,"PQfreeCancel",1024);
# endif
# if defined(HAVE_PQCANCEL)
  register_foreign_function((void*)&PQcancel,"PQcancel",1024);
# endif
# if defined(HAVE_PQREQUESTCANCEL)
  register_foreign_function((void*)&PQrequestCancel,"PQrequestCancel",1024);
# endif
# if defined(HAVE_PQDB)
  register_foreign_function((void*)&PQdb,"PQdb",1024);
# endif
# if defined(HAVE_PQUSER)
  register_foreign_function((void*)&PQuser,"PQuser",1024);
# endif
# if defined(HAVE_PQPASS)
  register_foreign_function((void*)&PQpass,"PQpass",1024);
# endif
# if defined(HAVE_PQHOST)
  register_foreign_function((void*)&PQhost,"PQhost",1024);
# endif
# if defined(HAVE_PQPORT)
  register_foreign_function((void*)&PQport,"PQport",1024);
# endif
# if defined(HAVE_PQTTY)
  register_foreign_function((void*)&PQtty,"PQtty",1024);
# endif
# if defined(HAVE_PQOPTIONS)
  register_foreign_function((void*)&PQoptions,"PQoptions",1024);
# endif
# if defined(HAVE_PQSTATUS)
  register_foreign_function((void*)&PQstatus,"PQstatus",1024);
# endif
# if defined(HAVE_PQTRANSACTIONSTATUS)
  register_foreign_function((void*)&PQtransactionStatus,"PQtransactionStatus",1024);
# endif
# if defined(HAVE_PQPARAMETERSTATUS)
  register_foreign_function((void*)&PQparameterStatus,"PQparameterStatus",1024);
# endif
# if defined(HAVE_PQPROTOCOLVERSION)
  register_foreign_function((void*)&PQprotocolVersion,"PQprotocolVersion",1024);
# endif
# if defined(HAVE_PQSERVERVERSION)
  register_foreign_function((void*)&PQserverVersion,"PQserverVersion",1024);
# endif
# if defined(HAVE_PQERRORMESSAGE)
  register_foreign_function((void*)&PQerrorMessage,"PQerrorMessage",1024);
# endif
# if defined(HAVE_PQSOCKET)
  register_foreign_function((void*)&PQsocket,"PQsocket",1024);
# endif
# if defined(HAVE_PQBACKENDPID)
  register_foreign_function((void*)&PQbackendPID,"PQbackendPID",1024);
# endif
# if defined(HAVE_PQCLIENTENCODING)
  register_foreign_function((void*)&PQclientEncoding,"PQclientEncoding",1024);
# endif
# if defined(HAVE_PQSETCLIENTENCODING)
  register_foreign_function((void*)&PQsetClientEncoding,"PQsetClientEncoding",1024);
# endif
# if defined(HAVE_PQGETSSL)
  register_foreign_function((void*)&PQgetssl,"PQgetssl",1024);
# endif
# if defined(HAVE_PQINITSSL)
  register_foreign_function((void*)&PQinitSSL,"PQinitSSL",1024);
# endif
# if defined(HAVE_PQSETERRORVERBOSITY)
  register_foreign_function((void*)&PQsetErrorVerbosity,"PQsetErrorVerbosity",1024);
# endif
# if defined(HAVE_PQTRACE)
  register_foreign_function((void*)&PQtrace,"PQtrace",1024);
# endif
# if defined(HAVE_PQUNTRACE)
  register_foreign_function((void*)&PQuntrace,"PQuntrace",1024);
# endif
# if defined(HAVE_PQSETNOTICERECEIVER)
  register_foreign_function((void*)&PQsetNoticeReceiver,"PQsetNoticeReceiver",1024);
# endif
# if defined(HAVE_PQSETNOTICEPROCESSOR)
  register_foreign_function((void*)&PQsetNoticeProcessor,"PQsetNoticeProcessor",1024);
# endif
# if defined(HAVE_PQEXEC)
  register_foreign_function((void*)&PQexec,"PQexec",1024);
# endif
# if defined(HAVE_PQEXECPARAMS)
  register_foreign_function((void*)&PQexecParams,"PQexecParams",1024);
# endif
# if defined(HAVE_PQPREPARE)
  register_foreign_function((void*)&PQprepare,"PQprepare",1024);
# endif
# if defined(HAVE_PQEXECPREPARED)
  register_foreign_function((void*)&PQexecPrepared,"PQexecPrepared",1024);
# endif
# if defined(HAVE_PQSENDQUERY)
  register_foreign_function((void*)&PQsendQuery,"PQsendQuery",1024);
# endif
# if defined(HAVE_PQSENDQUERYPARAMS)
  register_foreign_function((void*)&PQsendQueryParams,"PQsendQueryParams",1024);
# endif
# if defined(HAVE_PQSENDPREPARE)
  register_foreign_function((void*)&PQsendPrepare,"PQsendPrepare",1024);
# endif
# if defined(HAVE_PQSENDQUERYPREPARED)
  register_foreign_function((void*)&PQsendQueryPrepared,"PQsendQueryPrepared",1024);
# endif
# if defined(HAVE_PQGETRESULT)
  register_foreign_function((void*)&PQgetResult,"PQgetResult",1024);
# endif
# if defined(HAVE_PQISBUSY)
  register_foreign_function((void*)&PQisBusy,"PQisBusy",1024);
# endif
# if defined(HAVE_PQCONSUMEINPUT)
  register_foreign_function((void*)&PQconsumeInput,"PQconsumeInput",1024);
# endif
# if defined(HAVE_PQNOTIFIES)
  register_foreign_function((void*)&PQnotifies,"PQnotifies",1024);
# endif
# if defined(HAVE_PQPUTCOPYDATA)
  register_foreign_function((void*)&PQputCopyData,"PQputCopyData",1024);
# endif
# if defined(HAVE_PQPUTCOPYEND)
  register_foreign_function((void*)&PQputCopyEnd,"PQputCopyEnd",1024);
# endif
# if defined(HAVE_PQGETCOPYDATA)
  register_foreign_function((void*)&PQgetCopyData,"PQgetCopyData",1024);
# endif
# if defined(HAVE_PQGETLINE)
  register_foreign_function((void*)&PQgetline,"PQgetline",1024);
# endif
# if defined(HAVE_PQPUTLINE)
  register_foreign_function((void*)&PQputline,"PQputline",1024);
# endif
# if defined(HAVE_PQGETLINEASYNC)
  register_foreign_function((void*)&PQgetlineAsync,"PQgetlineAsync",1024);
# endif
# if defined(HAVE_PQPUTNBYTES)
  register_foreign_function((void*)&PQputnbytes,"PQputnbytes",1024);
# endif
# if defined(HAVE_PQENDCOPY)
  register_foreign_function((void*)&PQendcopy,"PQendcopy",1024);
# endif
# if defined(HAVE_PQSETNONBLOCKING)
  register_foreign_function((void*)&PQsetnonblocking,"PQsetnonblocking",1024);
# endif
# if defined(HAVE_PQISNONBLOCKING)
  register_foreign_function((void*)&PQisnonblocking,"PQisnonblocking",1024);
# endif
# if defined(HAVE_PQFLUSH)
  register_foreign_function((void*)&PQflush,"PQflush",1024);
# endif
# if defined(HAVE_PQFN)
  register_foreign_function((void*)&PQfn,"PQfn",1024);
# endif
# if defined(HAVE_PQRESULTSTATUS)
  register_foreign_function((void*)&PQresultStatus,"PQresultStatus",1024);
# endif
# if defined(HAVE_PQRESSTATUS)
  register_foreign_function((void*)&PQresStatus,"PQresStatus",1024);
# endif
# if defined(HAVE_PQRESULTERRORMESSAGE)
  register_foreign_function((void*)&PQresultErrorMessage,"PQresultErrorMessage",1024);
# endif
# if defined(HAVE_PQRESULTERRORFIELD)
  register_foreign_function((void*)&PQresultErrorField,"PQresultErrorField",1024);
# endif
# if defined(HAVE_PQNTUPLES)
  register_foreign_function((void*)&PQntuples,"PQntuples",1024);
# endif
# if defined(HAVE_PQNFIELDS)
  register_foreign_function((void*)&PQnfields,"PQnfields",1024);
# endif
# if defined(HAVE_PQBINARYTUPLES)
  register_foreign_function((void*)&PQbinaryTuples,"PQbinaryTuples",1024);
# endif
# if defined(HAVE_PQFNAME)
  register_foreign_function((void*)&PQfname,"PQfname",1024);
# endif
# if defined(HAVE_PQFNUMBER)
  register_foreign_function((void*)&PQfnumber,"PQfnumber",1024);
# endif
# if defined(HAVE_PQFTABLE)
  register_foreign_function((void*)&PQftable,"PQftable",1024);
# endif
# if defined(HAVE_PQFTABLECOL)
  register_foreign_function((void*)&PQftablecol,"PQftablecol",1024);
# endif
# if defined(HAVE_PQFFORMAT)
  register_foreign_function((void*)&PQfformat,"PQfformat",1024);
# endif
# if defined(HAVE_PQFTYPE)
  register_foreign_function((void*)&PQftype,"PQftype",1024);
# endif
# if defined(HAVE_PQFSIZE)
  register_foreign_function((void*)&PQfsize,"PQfsize",1024);
# endif
# if defined(HAVE_PQFMOD)
  register_foreign_function((void*)&PQfmod,"PQfmod",1024);
# endif
# if defined(HAVE_PQCMDSTATUS)
  register_foreign_function((void*)&PQcmdStatus,"PQcmdStatus",1024);
# endif
# if defined(HAVE_PQOIDSTATUS)
  register_foreign_function((void*)&PQoidStatus,"PQoidStatus",1024);
# endif
# if defined(HAVE_PQOIDVALUE)
  register_foreign_function((void*)&PQoidValue,"PQoidValue",1024);
# endif
# if defined(HAVE_PQCMDTUPLES)
  register_foreign_function((void*)&PQcmdTuples,"PQcmdTuples",1024);
# endif
# if defined(HAVE_PQGETVALUE)
  register_foreign_function((void*)&PQgetvalue,"PQgetvalue",1024);
# endif
# if defined(HAVE_PQGETLENGTH)
  register_foreign_function((void*)&PQgetlength,"PQgetlength",1024);
# endif
# if defined(HAVE_PQGETISNULL)
  register_foreign_function((void*)&PQgetisnull,"PQgetisnull",1024);
# endif
# if defined(HAVE_PQCLEAR)
  register_foreign_function((void*)&PQclear,"PQclear",1024);
# endif
# if defined(HAVE_PQFREEMEM)
  register_foreign_function((void*)&PQfreemem,"PQfreemem",1024);
# endif
# if defined(HAVE_PQMAKEEMPTYPGRESULT)
  register_foreign_function((void*)&PQmakeEmptyPGresult,"PQmakeEmptyPGresult",1024);
# endif
# if defined(HAVE_PQESCAPESTRING)
  register_foreign_function((void*)&PQescapeString,"PQescapeString",1024);
# endif
# if defined(HAVE_PQESCAPEBYTEA)
  register_foreign_function((void*)&PQescapeBytea,"PQescapeBytea",1024);
# endif
# if defined(HAVE_PQUNESCAPEBYTEA)
  register_foreign_function((void*)&PQunescapeBytea,"PQunescapeBytea",1024);
# endif
# if defined(HAVE_PQPRINT)
  register_foreign_function((void*)&PQprint,"PQprint",1024);
# endif
# if defined(HAVE_PQDISPLAYTUPLES)
  register_foreign_function((void*)&PQdisplayTuples,"PQdisplayTuples",1024);
# endif
# if defined(HAVE_PQPRINTTUPLES)
  register_foreign_function((void*)&PQprintTuples,"PQprintTuples",1024);
# endif
# if defined(HAVE_LO_OPEN)
  register_foreign_function((void*)&lo_open,"lo_open",1024);
# endif
# if defined(HAVE_LO_CLOSE)
  register_foreign_function((void*)&lo_close,"lo_close",1024);
# endif
# if defined(HAVE_LO_READ)
  register_foreign_function((void*)&lo_read,"lo_read",1024);
# endif
# if defined(HAVE_LO_WRITE)
  register_foreign_function((void*)&lo_write,"lo_write",1024);
# endif
# if defined(HAVE_LO_LSEEK)
  register_foreign_function((void*)&lo_lseek,"lo_lseek",1024);
# endif
# if defined(HAVE_LO_CREAT)
  register_foreign_function((void*)&lo_creat,"lo_creat",1024);
# endif
# if defined(HAVE_LO_TELL)
  register_foreign_function((void*)&lo_tell,"lo_tell",1024);
# endif
# if defined(HAVE_LO_UNLINK)
  register_foreign_function((void*)&lo_unlink,"lo_unlink",1024);
# endif
# if defined(HAVE_LO_IMPORT)
  register_foreign_function((void*)&lo_import,"lo_import",1024);
# endif
# if defined(HAVE_LO_EXPORT)
  register_foreign_function((void*)&lo_export,"lo_export",1024);
# endif
# if defined(HAVE_PQMBLEN)
  register_foreign_function((void*)&PQmblen,"PQmblen",1024);
# endif
# if defined(HAVE_PQDSPLEN)
  register_foreign_function((void*)&PQdsplen,"PQdsplen",1024);
# endif
# if defined(HAVE_PQENV2ENCODING)
  register_foreign_function((void*)&PQenv2encoding,"PQenv2encoding",1024);
# endif
}

void module__postgresql__fini_function (module_t* module)
{
}
